/// @file samplestatcompressor.hpp
/// Sample statistical compressor
///
/// @remarks
/// This sample compressor is based on statistical compressor, and just
///  creates a 3-component compressor out of sample parser/model/coder.
///
/// @author mouser
/// @date   2003.07.29
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// recursive header protection
#ifndef SampleStatCompressorH
#define SampleStatCompressorH
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// application includes
#include "../compressor_statistical.hpp"
#include "../../coders/coder_sample/samplecoder.hpp"
#include "../../parsers/parser_sample/sampleparser.hpp"
#include "../../modelers/modeler_sample/samplemodeler.hpp"
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
/// This Sample Statistical Compressor is a minimal example of how to
///  coordinate the 3 components of the statistical compressor framework,
///  a sample parser,modeler,and coder.
///
/// @ingroup Compressors
///
class SampleStatCompressor : public OctaneCompressor_Statistical
{
public:
	/// constructor
	SampleStatCompressor(bool registerme=false);
	/// destructor
	~SampleStatCompressor() {;};
public:
	//---------------------------------------------------------------------------
	// OCTANE PUBLIC API - RTTI AND HELP FUNCTIONS - these are supported by all derived classes
	virtual std::string GetClassName() {return "StatSample";}
	virtual std::string GetDescription() {return "Sample Statistical Compressor";}
	//---------------------------------------------------------------------------
public:
	//---------------------------------------------------------------------------
	// COMPRESSOR PUBLIC API - FACTORY FUNCTION / MAKE AN INSTANTIATION OF DERIVED COMPRESSOR
	virtual OctaneCompressor *MakeCompressorInstantiation() {return new SampleStatCompressor();};
	//---------------------------------------------------------------------------
};
//---------------------------------------------------------------------------






//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
