/// @file zeroorder_modeler.hpp
/// A simple zero-order modeler, which just uses summary frequencies of symbols
///
/// @author mouser
/// @date   2003.07.29
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// recursive header protection
#ifndef ZeroOrderModelerH
#define ZeroOrderModelerH
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// application includes
#include "../modeler_weightvectored.hpp"
// system includes
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
/// A simple zero-order modeler, that builds its probability model by counting
/// frequencies in a training file.
///
/// @ingroup Modelers
///
class ZeroOrderModeler : public OctaneModeler_WeightVectored
{
public:
	/// constructor
	ZeroOrderModeler() : OctaneModeler_WeightVectored() {;}
	/// destructor
	virtual ~ZeroOrderModeler() {;}
public:
	//---------------------------------------------------------------------------
	// OCTANE PUBLIC API - RTTI FUNCTIONS - these are supported by all derived classes
	virtual std::string GetName() {return "ZeroOrderModeler";}
	virtual std::string GetDescription() {return "Zero-order Modeler";}
	//---------------------------------------------------------------------------
public:
	//---------------------------------------------------------------------------
	// MODELLER PUBLIC API - ACCESSOR FOR CODING
	virtual bool CreateModelUsingStream(OctaneParser *parserp, bitreader &from);
	//---------------------------------------------------------------------------
};
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------

